Attribute VB_Name = "Quer_Drucken"
Option Explicit

Public aTab(0 To 10) As Integer, Tab0 As Integer
Public strZ(0 To 10) As String
Public p As Object

Public Sub Dr_Einrichten(idr_S)
'Drucksteuerung
Dim BeginPage As Integer, EndPage As Integer
Dim Anz_Copies As Integer                      '5.1
Dim msg As String

Set p = Printer
With p
  p.ScaleMode = 6                  'in mm
  p.FontName = "arial"             'geht (jedoch ohne Tabs)
End With

Anfangsseite = Val(InputBox("Anfangsseite", , "1"))
Anh_Bez = InputBox("Anhangbezeichnung", , "A")

Anz_Copies = 1

With MDIfrm_Quer.CommonDialog1
  .CancelError = True
  If Err = MScomdlg.cdlCancel Then Exit Sub
  On Error GoTo ErrHandler3
  .PrinterDefault = True
  .DialogTitle = "Druckerauswahl"
  .Copies = Anz_Copies
  .Min = Anfangsseite
  .Max = Anfangsseite + SumSeite - 1
  .FromPage = .Min
  .ToPage = .Max
  .Flags = cdlPDPageNums
  .ShowPrinter

  BeginPage = .FromPage
  EndPage = .ToPage
End With

idr = 1

If idr_S < 3 Then
  Seite = Anfangsseite
  Call Dr_ber
  Call Dr_Ausgaben
  Printer.EndDoc
End If

If idr_S = 2 Then
  Seite = Seite + 1
  Call Dr_ber
  Call graphik
  Printer.EndDoc
End If

If idr_S = 3 Then
  Seite = Anfangsseite
  Call Dr_ber
  Call graphik
  Printer.EndDoc
End If

Exit Sub

ErrHandler3:
  idr = 0
  msg = "Die Ausgabe konnte nicht gedruckt werden. " + Err.Description
  MsgBox msg

End Sub   'Dr_Einrichten

Sub Dr_Ausgaben()   'Ausgaben auf Drucker
Dim i As Integer
Dim strF As String

Set p = Printer

With p
  p.ScaleMode = 6              'in mm
  p.FontName = "arial"

  Call Tabulatoren             'Standardtabulatoren

  p.FontSize = 15
  p.FontBold = True
  p.CurrentX = Tab0
  p.Print "Programm  " + strPgmName + ", Version " + strVersion
  p.Print

  'Eingaben Querschnitt
  p.CurrentX = Tab0
  If strQuer = "T" Then
    p.Print "*** Quer" + strQuer + " - Querschnitt ***"
  Else
    p.Print "*** Quer" + strQuer + " - Eckpunkte ***"
  End If
  p.Print

  p.FontSize = 12
  p.FontBold = False
  '... aus Teilquerschnitten
  If strQuer = "T" Then
    p.CurrentX = Tab0: p.Print "Zahl der Teilquerschnitte   n = "; N
    p.CurrentX = Tab0: p.Print "Gesamthhe des Querschnitts hG = "; hg;
    p.Print strEHL
    p.Print
  
    strZ(0) = "Nr."
    strZ(1) = "Profil": strZ(2) = "b bzw. A"
    strZ(3) = "h bzw. I": strZ(4) = "zS"
    aTab(3) = 95: aTab(4) = 110
    Call TabZahlDr(4, 1, p)
    
    p.CurrentX = Tab0
    p.CurrentY = p.CurrentY + 1
    p.Line (Tab0, p.CurrentY)-(180, p.CurrentY)
    p.CurrentY = p.CurrentY + 1

    For i = 1 To N
      strZ(0) = Format(i, "#00")
      strZ(1) = Str(Form(i))
      strZ(2) = Format(b(i), "#0.000")
      strZ(3) = Format(h(i), "#0.000")
      strZ(4) = Format(zs(i), "#0.000")
      Call TabZahlDr(4, 1, p)
    Next i
    p.Print
    p.CurrentX = Tab0
    p.Print "Erluterung: 1 = Rechteck, 2 = Profil"
    If NS <> 0 Or My <> 0 Or Mz <> 0 Then Call Dr_Schnittkrfte
  End If               'Ende QuerT

  '... polygonal berandet ----------------------------------
  If strQuer = "P" Then
    p.CurrentX = Tab0: p.Print "Zahl der Eckpunkte  n = "; N
  
    strZ(0) = "Nr."
    strZ(1) = "y [" + strEHL + "]"
    strZ(2) = "z [" + strEHL + "]"
    Call TabZahlDr(2, 1, p)
  
    For i = 1 To N
      strZ(0) = Format(i, "#00")
      strZ(1) = Format(y(i), "#0.000")
      strZ(2) = Format(z(i), "#0.000")
      Call TabZahlDr(2, 1, p)
    Next i
    If NS <> 0 Or My <> 0 Or Mz <> 0 Then Call Dr_Schnittkrfte
  End If

  '... mit Ausrundungen
  If strQuer = "A" Then
    p.CurrentX = Tab0
    If blnSonderz Then                                      '5.11
      p.Print "Polygonwinkel der Ausrundungen ";
      Call symb("g"): p.Print " = ";
    Else
      p.Print "Polygonwinkel der Ausrundungen gamma = ";
    End If
    p.Print Format(gamma, "####0.000")
    
    p.CurrentX = Tab0: p.Print "Zahl der Eckpunkte nE = "; NE
    p.CurrentX = Tab0: p.Print "Anfangswinkel  (0) = ";
    p.Print Format(beta(0), "####0.000")
    p.CurrentX = Tab0: p.Print "Ausrundungsradien und relative Koordinaten"
    p.Print
  
    strZ(0) = ""
    strZ(1) = "Ausrundungsradius"
    strZ(2) = "Winkel"
    strZ(3) = "Kantenlnge"
    Call TabZahlDr(3, 1, p)
  
    strZ(0) = "Nr."
    strZ(1) = "r [" + strEHL + "]"
    strZ(2) = "alfa []"
    strZ(3) = "L [" + strEHL + "]"
    Call TabZahlDr(3, 1, p)
    p.CurrentX = Tab0
    p.CurrentY = p.CurrentY + 1
    p.Line (Tab0, p.CurrentY)-(180, p.CurrentY)
    p.CurrentY = p.CurrentY + 1
  
    For i = 1 To NE
      strZ(0) = Format(i, "#00")
      strZ(1) = Format(R(i), "#0.000")
      strZ(2) = Format(alfa(i), "#0.000")
      strZ(3) = Format(xL(i), "#0.000")
      Call TabZahlDr(3, 1, p)
    Next i
    If NS <> 0 Or My <> 0 Or Mz <> 0 Then Call Dr_Schnittkrfte
  End If

  'Ergebnisse
  p.Print
  p.FontSize = 15
  p.FontBold = True
  p.CurrentX = Tab0
  p.Print "*** Quer" + strQuer + " - Ergebnisse ***"
  p.Print
  
  aTab(1) = 90
  aTab(2) = 120
  aTab(3) = 135
  strF = "####0.0000"
  If Iy > 10000 Or Iz > 10000 Then strF = "####0.00"
  If Iy > 1000000 Or Iz > 1000000 Then strF = "####0"
  
  p.FontSize = 12
  p.FontBold = False
  strZ(0) = "Flche": strZ(1) = "A = "
  strZ(2) = Format(A, "#0.000"): strZ(3) = strEHL + ""
  Call TabZahlDr(3, 1, p)

  strZ(0) = "Schwerachse": strZ(1) = "zs = "
  strZ(2) = Format(zzs, "#0.000"): strZ(3) = strEHL
  Call TabZahlDr(3, 1, p)

  If strQuer <> "T" Then
    p.CurrentX = Tab0
    strZ(0) = "Schwerachse": strZ(1) = "ys = "
    strZ(2) = Format(ys, "#0.000"): strZ(3) = strEHL
    Call TabZahlDr(3, 1, p)
  End If
  strZ(0) = "Flchenmoment 2. Grades": strZ(1) = "Iy = "
  strZ(2) = Format(Iy, strF): strZ(3) = strEHL + "4"
  Call TabZahlDr(3, 1, p)
  
  If strQuer <> "T" Then
    strZ(0) = "Flchenmoment 2. Grades": strZ(1) = "Iz = "
    strZ(2) = Format(Iz, strF): strZ(3) = strEHL + "4"
    Call TabZahlDr(3, 1, p)
    strZ(0) = "Hauptwinkel": strZ(1) = "phi = "
    strZ(2) = Format(phi, "#0.000"): strZ(3) = " "
    Call TabZahlDr(3, 1, p)
    p.Print
    strZ(0) = "Hauptflchenmoment 2.Gr.": strZ(1) = "I1 = "
    strZ(2) = Format(I1, strF): strZ(3) = strEHL + "4"
    Call TabZahlDr(3, 1, p)
    strZ(0) = "Hauptflchenmoment 2.Gr.": strZ(1) = "I2 = "
    strZ(2) = Format(I2, strF): strZ(3) = strEHL + "4"
    Call TabZahlDr(3, 1, p)
  Else
    strZ(0) = "Widerstandsmoment oben": strZ(1) = "Wo = "
    strZ(2) = Format(Wo, "#0.000"): strZ(3) = strEHL + ""
    Call TabZahlDr(3, 1, p)
    strZ(0) = "Widerstandsmoment unten": strZ(1) = "Wu = "
    strZ(2) = Format(Wu, "#0.000"): strZ(3) = strEHL + ""
    Call TabZahlDr(3, 1, p)
  End If
  
  If NS <> 0 Or My <> 0 Or Mz <> 0 Then
    p.Print
    If strQuer = "T" Then
      strZ(0) = "Randspannung oben": strZ(1) = "sigo = "
      strZ(2) = Format(maxs, "#0.000"): strZ(3) = strEHF + "/" + strEHL + ""
      Call TabZahlDr(3, 1, p)
      strZ(0) = "Randspannung unten": strZ(1) = "sigu = "
      strZ(2) = Format(mins, "#0.000"): strZ(3) = strEHF + "/" + strEHL + ""
      Call TabZahlDr(3, 1, p)
    End If
    If strQuer = "P" Then
      For i = 1 To N - 1
        strZ(0) = "Spannung sig ": strZ(1) = Str(i)
        strZ(2) = Format(SIG(i), "#0.000"): strZ(3) = strEHF + "/" + strEHL + ""
        Call TabZahlDr(3, 1, p)
      Next i
    End If
    If strQuer = "P" Or strQuer = "A" Then
      strZ(0) = "maximale Spannung": strZ(1) = "maxs = "
      strZ(2) = Format(maxs, "#0.000"): strZ(3) = strEHF + "/" + strEHL + ""
      Call TabZahlDr(3, 1, p)
      strZ(0) = "minimale Spannung": strZ(1) = "mins = "
      strZ(2) = Format(mins, "#0.000"): strZ(3) = strEHF + "/" + strEHL + ""
      Call TabZahlDr(3, 1, p)
    End If
  End If

End With

End Sub   'Dr_Ausgaben

Public Sub Dr_Schnittkrfte()
'Drucken der Schnittkrfte N, My und Mz
Dim strF As String

strF = "####0.00"
aTab(1) = 90
aTab(2) = 120
aTab(3) = 135

Set p = Printer
With p
  p.Print
  strZ(0) = "Normalkraft": strZ(1) = "N = "
  strZ(2) = Str(NS): strZ(3) = strEHF
  Call TabZahlDr(3, 1, p)
    
  strZ(0) = "Biegemoment": strZ(1) = "My = "
  strZ(2) = Format(My, strF): strZ(3) = strEHF + strEHL
  Call TabZahlDr(3, 1, p)
    
  If strQuer = "T" Then Exit Sub
    
  strZ(0) = "Biegemoment": strZ(1) = "Mz = "
  strZ(2) = Format(Mz, strF): strZ(3) = strEHF + strEHL
  Call TabZahlDr(3, 1, p)
End With

Call Tabulatoren

End Sub   'Dr_Schnittkrfte

Sub hoch(ByVal text As String, ByVal Fonta As Integer, ByVal Fonth As Integer, _
         ByVal ycorrect As Single, ByVal NeueZeile As Integer)
  Dim xPos As Integer, yPos As Integer
  'Hochstellen von text
  'Fonta = normale Fontsize in pt
  'Fonth = Fontsize von text in pt
  'Diffh = Verschiebung von text nach oben (Bsp. 12pt: 0.2)
  'NeueZeile% = 0: weiterschreiben, =1: Zeilenumbruch
  'Voraussetzung bei Aufruf: set p = Printer
  xPos = p.CurrentX
  yPos = p.CurrentY
  p.FontSize = Fonth
  p.CurrentY = p.CurrentY - ycorrect
  p.Print text;
  p.CurrentY = yPos
  p.FontSize = Fonta
  p.Print " ";                           'ggf. entfernen
  If NeueZeile = 1 Then p.Print
End Sub   'hoch

Public Sub Tief(ByVal text As String, ByVal Fonta As Integer, ByVal Fonth As Integer, _
                ByVal ycorrect As Single, ByVal NeueZeile As Integer)
  Dim xPos As Integer, yPos As Integer
  'Tiefstellen von text
  'Fonta = normale Fontsize in pt
  'Fonth = Fontsize von tx$ in pt
  'Diffh = Verschiebung von text nach unten (Bsp. 12pt: 0.8)
  'NeueZeile% = 0: weiterschreiben, =1: Zeilenumbruch
  'Voraussetzung bei Aufruf: set p = Printer
  xPos = p.CurrentX
  yPos = p.CurrentY
  p.FontSize = Fonth
  p.CurrentY = p.CurrentY + ycorrect
  p.Print text;
  p.CurrentY = yPos
  p.FontSize = Fonta
  p.Print " ";                           'ggf. entfernen
  If NeueZeile = 1 Then p.Print
End Sub   'Tief

Sub symb(ByVal text As String)
  Dim ycorrect As Single, xPos As Integer
  'druckt ein Symbolzeichen mit Korrekturen x und y
  'Voraussetzung: Scalemode = 4 (Zeichen)
  'ycorrect = .1   '10 % vert. Korr. (nicht bei Arial)
  ycorrect = 0.1
  Set p = Printer
  With p
    p.ScaleMode = 4            'Zeichen
    xPos = p.CurrentX
    p.FontName = "Symbol"
    p.CurrentY = p.CurrentY - ycorrect
    p.Print text;
    p.CurrentY = p.CurrentY + ycorrect
    p.FontName = "arial"
    p.CurrentX = xPos + 1
    p.ScaleMode = 6             'zurck in mm
  End With
End Sub   'symb

Public Sub Dr_ber()
'Ausgabe der Kopfzeilen
Dim RText As String
Dim Tab1 As Integer, Tab4 As Integer
Tab0 = 20                    'Beginn Text
Tab1 = 40                    'Projekt, Position usw.
Tab4 = 180                   'Zahl, rechtsbndig

Set p = Printer
With p
  p.ScaleMode = 6              'in mm
  p.FontSize = 10
  p.FontName = "arial"
  p.CurrentY = 15

  p.CurrentX = Tab0
  p.Print "Fachhochschule Mnster";
  RText = "Liz. Nr.   FH01DT"
  p.CurrentX = Tab4 - p.TextWidth(RText)
  p.Print RText
  p.CurrentX = Tab0
  p.Print "FB Bauingenieurwesen, Postfach 3020";
  RText = "Tel. 0251/83-65218"
  p.CurrentX = Tab4 - p.TextWidth(RText)
  p.Print RText
  p.CurrentY = p.CurrentY + 2
  p.CurrentX = Tab0
  p.Print "Programm Quer" + strQuer + ", Version "; strVersion
  p.CurrentX = Tab0
  p.Print "Programmautor: Prof. Dr.-Ing. B. Falter";
  RText = "falter@fh-muenster.de"
  p.CurrentX = Tab4 - p.TextWidth(RText)
  p.Print RText
  p.CurrentY = p.CurrentY + 1
  p.CurrentX = Tab0
  p.Line (Tab0, p.CurrentY)-(Tab4, p.CurrentY)
  p.CurrentY = p.CurrentY + 1
  p.CurrentX = Tab0
  p.Print "Flchenwerte fr zusammengesetzte, polygonal berandete und ausgerundete Querschnitte";
  RText = "- " & Anh_Bez + Str(Trim(Seite)) + " -"
  p.CurrentX = Tab4 - p.TextWidth(RText)
  p.Print RText
  p.CurrentX = Tab0
  p.Print "Datum:";
  p.CurrentX = Tab1
  p.Print Date
  p.CurrentX = Tab0
  p.Print "Projekt:";
  p.CurrentX = Tab1
  If Seite = 1 Then
    p.Print strProjekt;
    If Len(strDateiName) <> 0 Then
      RText = "Datei: " + strDateiName
      If Len(RText) > 45 Then RText = Right(RText, 45)
      p.CurrentX = Tab4 - p.TextWidth(RText)
      p.Print RText
    Else
      p.Print
    End If
  Else
    p.Print strProjekt
  End If
  p.CurrentX = Tab0
  p.Print "Position:";
  p.CurrentX = Tab1
  p.Print strPosition;
  RText = "Einheiten: " + strEHF + "; " + strEHL
  p.CurrentX = Tab4 - p.TextWidth(RText)
  p.Print RText
  p.Print
End With

End Sub   'Dr_ber

Public Sub TabZahlDr(ByVal Zahl As Integer, ByVal ZU As Integer, _
                     ByVal p As Object)
  'rechtsbndige Ausgabe der Zahlen i2 und Zahl(NE), ggf. mit Einheit auf Drucker
  'Zahl = Anzahl der Tabellenelemente (Spalten)
  'ZU = 1 Zeilenumbruch, = 0 kein Zeilenumbruch
  'p = Druckerobjekt, definiert durch set p = printer
  'Public:
  'aTab( )= Position der Spalten
  'strZ( )= Inhalt der Spalten
  Dim j1 As Integer

  p.CurrentX = Tab0              '1. Spalte linksbndig
  p.Print strZ(0);
 
  For j1 = 1 To Zahl             'weitere Spalten rechtsbndig
    p.CurrentX = aTab(j1) - p.TextWidth(strZ(j1))
    p.Print strZ(j1);
  Next j1

  If ZU > 0 Then p.Print
  If ZU > 1 Then p.Print
End Sub   'TabZahlDr

Public Sub Tabulatoren()
  'Standardtabulatoren fr Druckausgaben
  Tab0 = 20                    'linker Rand 20 mm
  aTab(0) = 30                 '  eingerckter Text
  aTab(1) = aTab(0) + 25       '  eingerckter Text
  aTab(2) = 80                 'Beginn Variable, rechtsbndig
  aTab(3) = 105                'Zahl, rechtsbndig
  aTab(4) = 130                'Zahl, rechtsbndig
  aTab(5) = 155                'Zahl, rechtsbndig
  aTab(6) = 180                'Zahl, rechtsbndig
  aTab(7) = 190                'Zahl, rechtsbndig
End Sub   'Tabulatoren


