Attribute VB_Name = "Quer_Grafik"
Option Explicit

Sub graphik()
'Frafik System und Ergebnisse (nur QuerP, QuerA)
Dim i As Integer, BX0 As Integer, BY0 As Integer
Dim BX As Integer, BY As Integer
Dim XA As Single, XE As Single, YA As Single, YE As Single
Dim XX As Single, YY As Single, XR As Single
Dim XS1 As Single, ys1 As Single, XH As Single, YH As Single
Dim EX As Single, EY As Single, MX As Single
Dim zentx As Single, zenty As Single, xx1 As Single
Dim X2 As Single, yy1 As Single, Y2 As Single, XSL As Single, XSR As Single
Dim YSL As Single, YSR As Single
Dim xsig1 As Single, ysig1 As Single
Dim xsig2 As Single, ysig2 As Single, msig As Single
Dim Farbe_S As Long
Dim msg As String
Dim g As Object
ReDim X1(N + 1) As Single, y1(N + 1) As Single

If idr = -1 Then
  Set g = frm_Quer.Picture1
  g.Cls
ElseIf idr = 0 Then
  Set g = frm_Quer_graph
  g.Cls
ElseIf idr = 1 Then
  Set g = Printer
End If

On Error GoTo MGrFehler                  '5.1

With g
  If strQuer = "T" Then Exit Sub
  g.ScaleMode = 1        'Twips
  'Umbenennen der Koord. y->x1, z->y1
  For i = 1 To N + 1
    X1(i) = y(i): y1(i) = z(i)
  Next i
  XS1 = ys: ys1 = zzs
  BY0 = g.ScaleHeight
  BX0 = g.ScaleWidth
  BX = BX0: BY = BY0
  ' PIX = Seitenverhltnis der Pixel
  If idr <> 1 Then
    XR = CInt(BX / 100) * 10
  Else
    XR = CInt(BX / 100) * 20
  End If
  XX = BX - 2 * XR: YY = BY - 2 * XR
  ' min/max-Werte von x1 und y1
  XA = 100000!: XE = -XA: YA = 100000!: YE = -YA
  For i = 1 To N
    If XA > X1(i) Then XA = X1(i)
    If XE < X1(i) Then XE = X1(i)
    If YA > y1(i) Then YA = y1(i)
    If YE < y1(i) Then YE = y1(i)
  Next i
  EX = Abs(XE - XA): If EX = 0 Then EX = 1
  EY = Abs(YE - YA): If EY = 0 Then EY = 1
  MX = XX / EX: If MX > YY / EY Then MX = YY / EY
  'Bildzentrierung
  zentx = (XX - EX * MX) / 2: zenty = (YY - EY * MX) / 2
  If idr = 1 Then zenty = zenty - XR / 2
  'max. Spannung
  If maxbs = 0 Then maxbs = 1
  msig = XR / maxbs / 1.5

  xx1 = CInt(XR + MX * (XS1 - XA) + zentx)
  yy1 = CInt(XR + MX * (ys1 - YA) + zenty)
  For i = 1 To N
    xx1 = CInt(XR + MX * (X1(i) - XA) + zentx)
    X2 = CInt(XR + MX * (X1(i + 1) - XA) + zentx)
    yy1 = CInt(XR + MX * (y1(i) - YA) + zenty)
    Y2 = CInt(XR + MX * (y1(i + 1) - YA) + zenty)
    ' Anfangspunkt
    If i = 1 Then
      g.Circle (xx1, CInt(BY - yy1)), BX / 100
    End If
    'Querschnitt
    g.Line (xx1, BY - yy1)-(X2, BY - Y2), RGB(0, 0, 255)
  
    ' Spannungen
    blnSpannung = True

    If idr <> 1 Then
      Farbe_S = RGB(255, 0, 0)
    Else
      Farbe_S = RGB(0, 0, 255)
    End If
  
    If blnSpannung And iBer = 1 Then
      xsig1 = xx1 + msig * SIG(i)
      ysig1 = yy1 + msig * SIG(i)
      xsig2 = X2 + msig * SIG(i + 1)
      ysig2 = Y2 + msig * SIG(i + 1)
      g.Line (xsig1, BY - ysig1)-(xsig2, BY - ysig2), Farbe_S
      g.Line (xx1, BY - yy1)-(xsig1, BY - ysig1), Farbe_S
    End If
  Next i
  
  'Hauptachsen
  'nur falls Berechnung erfolgte
  g.DrawStyle = 3              'Linie strichpunktiert
  XH = 0.6 * EX * Cos(phi * PA)
  YH = 0.6 * EX * Sin(phi * PA)

  XSR = CInt(XR + MX * (XS1 + XH - XA) + zentx)
  YSR = CInt(XR + MX * (ys1 + YH - YA) + zenty)
  XSL = CInt(XR + MX * (XS1 - XH - XA) + zentx)
  YSL = CInt(XR + MX * (ys1 - YH - YA) + zenty)
  If idr < 1 Then
    g.Line (XSL, BY - YSL)-(XSR, BY - YSR), RGB(100, 0, 0)
  Else
    g.Line (XSL, BY - YSL)-(XSR, BY - YSR), QBColor(0)
  End If
  
  If Not blnHauptachsen Then    '5.1
    g.DrawStyle = 0             'ausgezogene Linien
    Exit Sub
  End If
  
  'vertikale Achse
  XSR = CInt(XR + MX * (XS1 + YH - XA) + zentx)
  YSR = CInt(XR + MX * (ys1 - XH - YA) + zenty)
  XSL = CInt(XR + MX * (XS1 - YH - XA) + zentx)
  YSL = CInt(XR + MX * (ys1 + XH - YA) + zenty)
  If idr < 1 Then
    g.Line (XSL, BY - YSL)-(XSR, BY - YSR), RGB(100, 0, 0)
  Else
    g.Line (XSL, BY - YSL)-(XSR, BY - YSR), QBColor(0)
  End If
  g.DrawStyle = 0               'ausgezogene Linien

  blnBerech = False
End With
Exit Sub

MGrFehler:                       '5.1
  msg = "Fehler " + Err.Description + " bei der Grafikausgabe"
  MsgBox msg
End Sub   'graphik

