Attribute VB_Name = "Quer_Berechnen"
Option Explicit

' Eingaben
Public strProjekt As String, strPosition As String
Public strDateiName As String
Public vers1$, EH$
Public strQuer As String
Public strEHL As String, strEHF As String
Public N As Integer, NE As Integer
Public hg As Single
Public Form(1 To 200) As Single, b(1 To 200) As Single
Public h(1 To 200) As Single, zs(1 To 200) As Single
Public y(1 To 200) As Single, z(1 To 200) As Single
Public Y0(1 To 200) As Single, Z0(1 To 200) As Single
Public xL(1 To 200) As Single, beta(0 To 200) As Single, R(1 To 200) As Single
Public alfa(1 To 200) As Single
Public gamma As Single
Public NS As Single, My As Single, Mz As Single, vers2 As Single
' Ergebnisse
Public blnBerech As Boolean
Public iBer As Integer
Public A As Single, zzs As Single, ys As Single
Public Iy As Single, Iz As Single, IYZ As Single
Public I1 As Single, I2 As Single, phi As Single
Public SIG(1 To 200) As Single
Public maxs As Single, mins As Single
Public Wo As Single, Wu As Single
Public idr As Integer
Public maxbs As Single
Public blnSpannung As Boolean

Public blnProjausDatei As Boolean, blnHauptachsen As Boolean
Public Anfangsseite As Integer, Seite As Integer, SumSeite As Integer
Public Anh_Bez As String, Pfad As String

Public Tol As Single

Public Tab0 As Integer, TabI As Integer, DTab As Integer
Public idr_S As Integer
Public blnGrafik As Boolean           '5.1
Public blnSonderz As Boolean          '5.11

Public Const strPgmName = "Quer.vbp"
Public Const strVersion = "5.11"
Public Const PI = 3.14159
Public Const PA = PI / 180

Public Sub Hauptprogramm()
  'Steuerung der Berechnung
  'Version 5.1: delta in Tol (%) umbenannt
  '             Winkeleingabeprfung fr -360 bis 360
  '             Variable Seite nur als Public vereinbart
  '             Zeichnung wird bei Neuwahl gelscht
  '             Warnung bei Grafikwahl ohne Berechnung (blnGrafik = False)
  '             Belegen der Eingabezeile mit Sub EingabeZ1 (neu)
  
  blnProjausDatei = False

  If N = 0 And NE = 0 Then
    MsgBox ("Vor der Berechnung sind Daten einzugeben!")
    Exit Sub
  End If

  Call EingabeYZ

  Select Case strQuer
    Case "T": Call QuerT
    Case "P": Call QuerP
    Case "A": Call QuerA
  End Select

  Call BsAusg
  Call ErgebnisYZ

  If strQuer <> "T" Then
    idr = -1
    iBer = 1
    Call graphik
    iBer = 0
    idr = 0
  End If

  blnBerech = False

End Sub   'Hauptprogramm

Sub BsAusg()
'Erluterungen in label14
Dim aus As String

With frm_Quer.Label14
  .Caption = ""
  aus = "Erluterungen: " + vbCrLf
  aus = aus + "A     = Flche " + vbCrLf
  If strQuer = "T" Then
    aus = aus + "zs    = Schwerpunktlage " + vbCrLf
    aus = aus + "Iy    = Flchenmoment 2. Grades " + vbCrLf
    aus = aus + "Wo  = Widerstandsmoment, obere Randfaser" + vbCrLf
    aus = aus + "Wu  = Widerstandsmoment, untere Randfaser" + vbCrLf
    aus = aus + "sigo/sigu = Randspannungen oben/unten"
  Else
    aus = aus + "zs/ys  = Schwerpunktlage " + vbCrLf
    aus = aus + "Iy/Iz  = Flchenmoment 2. Grades " + vbCrLf
    aus = aus + "phi     = Hauptachsenwinkel" + vbCrLf
    aus = aus + "I1/I2  = Hauptflchenmomente 2. Grades" + vbCrLf
    aus = aus + "maxs/mins = extremale Spannungen"
  End If
  .Caption = aus
End With
End Sub   'BsAusg

Sub QuerA()
'polygonal berandete Querschnitte mit Ausrundungen
Dim Nmax As Integer, i As Integer, j As Integer
Dim ii As Integer, NI As Integer
Dim LM As Single, delta As Single, YM As Single, ZM As Single
Dim dy As Single, dz As Single
Dim text As String

'Zwischenpunkte im Bereich von Ausrundungen
Nmax = 200
ii = 1
Y0(1) = 0: Z0(1) = 0
For i = 1 To NE
  beta(i) = beta(i - 1) + alfa(i)
  Y0(i + 1) = Y0(i) + xL(i) * Cos(PA * beta(i))
  Z0(i + 1) = Z0(i) + xL(i) * Sin(PA * beta(i))
  If R(i) = 0 Then
    y(ii) = Y0(i): z(ii) = Z0(i)
    ii = ii + 1
  Else
    LM = R(i) / Sin(PI / 2 - alfa(i) * PA / 2)
    delta = beta(i) * PA + PI / 2 * Sgn(alfa(i)) - alfa(i) * PA / 2
    YM = Y0(i) + LM * Cos(delta)
    ZM = Z0(i) + LM * Sin(delta)
    NI = Int(Abs(alfa(i) / gamma))
    For j = 0 To NI
      y(ii) = YM + R(i) * Cos(delta + PI + alfa(i) * PA * (j / NI - 0.5))
      z(ii) = ZM + R(i) * Sin(delta + PI + alfa(i) * PA * (j / NI - 0.5))
      ii = ii + 1
      If ii > Nmax Then
        MsgBox ("Fehler: nmax > 200, Winkel gamma vergrern!")
        Exit Sub
      End If
    Next j
  End If
  
  If ii > Nmax Then
    MsgBox ("Fehler: nmax > 200, Winkel gamma vergrern!")
    Exit Sub
  End If
Next i

' Kontrolle des Endpunktes P(NE+1)=P(1)
dy = Y0(1) - Y0(NE + 1)
If xL(1) = 0 Then
  MsgBox ("Es wurde kein Querschnitt eingegeben!")
  Exit Sub
End If
If (Abs(dy / xL(1)) > Tol) Then             '5.1
  text = "Fehler: dy = " & Format(dy * 100, "0.000") & " > " & Format(Tol * 100, "0.000") '5.1
  text = text & " %, Korrektur der Koordinaten!"
  MsgBox text
End If
dz = Z0(1) - Z0(NE + 1)
If (Abs(dz / xL(1)) > Tol) Then             '5.1
  text = "Fehler: dz = " & Format(dz * 100, "0.000") & " > " & Format(Tol * 100, "0.000") '5.1
  text = text & " %, Korrektur der Koordinaten!"
  MsgBox text
End If
N = ii - 1

'Berechnung als polygonal berandeter Querschnitt
Call QuerP

End Sub   'QuerA

Sub QuerP()
'Berechnung polygonal berandeter Querschnitte
Dim i As Integer, ii As Integer, Imax As Integer, Imin As Integer
Dim SY As Single, SZ As Single, X As Single
Dim K1 As Single, K2 As Single, K0 As Single
Dim M1 As Single, M2 As Single, y1 As Single, Z1 As Single

y(N + 1) = y(1): z(N + 1) = z(1)
A = 0: SY = 0: SZ = 0
Iy = 0: Iz = 0: IYZ = 0
For i = 1 To N
  ii = i + 1
  X = (y(i) * z(ii) - y(ii) * z(i)) / 2
  A = A + X
  SY = SY + X * (z(i) + z(ii)) / 3
  SZ = SZ + X * (y(i) + y(ii)) / 3
  Iy = Iy + X * (z(i) ^ 2 + z(i) * z(ii) + z(ii) ^ 2) / 6
  Iz = Iz + X * (y(i) ^ 2 + y(i) * y(ii) + y(ii) ^ 2) / 6
  IYZ = IYZ + X * (y(i) * z(i) + y(i) * z(ii) / 2 + y(ii) * z(i) / 2 + y(ii) * z(ii)) / 6
Next i

If Abs(A) < 0.00001 Then
  MsgBox ("Flche A < 1e-5, Korrektur der Koordinaten!")
  Exit Sub
End If

zzs = SY / A: ys = SZ / A
Iy = Iy - A * zzs ^ 2
Iz = Iz - A * ys ^ 2
IYZ = IYZ - A * ys * zzs
If blnHauptachsen Then
  K1 = (Iy - Iz) / Iy: K2 = IYZ / Iy: K0 = 0.00001
  If Abs(K1) < K0 And Abs(K2) < K0 Then phi = 0: GoTo MWeiter
  If Abs(K1) < K0 And IYZ < 0 Then phi = 45: GoTo MWeiter
  If Abs(K1) < K0 And IYZ > 0 Then phi = 135: GoTo MWeiter
  phi = Atn(2 * IYZ / (Iz - Iy)) * 90 / PI
  If Iz > Iy Then phi = phi + 90
MWeiter:
  I1 = (Iy + Iz) / 2 + Sqr((Iy - Iz) ^ 2 + 4 * IYZ ^ 2) / 2
  I2 = (Iy + Iz) / 2 - Sqr((Iy - Iz) ^ 2 + 4 * IYZ ^ 2) / 2
Else
  phi = 0
  I1 = Iy
  I2 = Iz
End If

' Spannungen
M1 = My * Cos(phi * PA) + Mz * Sin(phi * PA)
M2 = -My * Sin(phi * PA) + Mz * Cos(phi * PA)
maxs = -10000000000#: mins = 10000000000#
For i = 1 To N
  y1 = (y(i) - ys) * Cos(phi * PA) + (z(i) - zzs) * Sin(phi * PA)
  Z1 = -(y(i) - ys) * Sin(phi * PA) + (z(i) - zzs) * Cos(phi * PA)
  SIG(i) = NS / A - M1 / I1 * Z1 + M2 / I2 * y1
  If SIG(i) > maxs Then maxs = SIG(i): Imax = i
  If SIG(i) < mins Then mins = SIG(i): Imin = i
  maxbs = maxs
  If Abs(mins) > maxbs Then maxbs = Abs(mins)
Next i
SIG(N + 1) = SIG(1)

Endesub:
If maxbs = 0 Then maxbs = 1

End Sub   'QuerP

Sub QuerT()
'Berechnung zusammengesetzter Querschnitte
Dim i As Integer
Dim S As Single, T As Single, U As Single, V As Single

S = 0: T = 0: U = 0: V = 0
For i = 1 To N
If Form(i) = 1 Then    'Rechteck
  S = S + b(i) * h(i)
  T = T + b(i) * h(i) * zs(i)
  U = U + b(i) * h(i) * zs(i) ^ 2
  V = V + b(i) * h(i) ^ 3 / 12
Else                   'Profil
  S = S + b(i)
  T = T + b(i) * zs(i)
  U = U + b(i) * zs(i) ^ 2
  V = V + h(i)
End If
Next i
A = S
If S > 0 Then zzs = T / S: Iy = U + V - S * zzs ^ 2
If Abs(hg - zzs) > 0 Then Wo = -Iy / (hg - zzs)
If Abs(zzs) > 0 Then Wu = Iy / zzs
If Abs(A) > 0 And Abs(Wo) > 0 And Abs(Wu) > 0 Then
  maxs = NS / A + My / Wo
  mins = NS / A + My / Wu
End If

End Sub   'QuerT

Public Sub EingabeYZ()
'Eingaben in Flexgrid
Dim i As Integer

If strQuer = "A" Then
  If NE < 3 Then NE = 3
Else
  If N = 0 Then N = 1
End If
With frm_Quer.MSFlexGrid1
  .ScrollBars = 3
  Select Case strQuer
    Case "T": .Rows = N + 2: .Cols = 5
    Case "P": .Rows = N + 2: .Cols = 3
    Case "A": .Rows = NE + 2: .Cols = 4
  End Select
  .FixedRows = 2
  .FixedCols = 1
  
  .ColWidth(0) = .Width / 10
  For i = 1 To .Cols - 1
    Select Case strQuer
      Case "T": .ColWidth(i) = .Width / 4.8
                .ColWidth(1) = .Width / 4
      Case "P": .ColWidth(i) = .Width / 2.8
      Case "A": .ColWidth(i) = .Width / 3.5
    End Select
  Next i

  .FixedAlignment(0) = 2              'zentriert
  .Row = 0
  .Col = 0: .text = "Nr."

  If strQuer = "T" Then                'Fall T
    .Row = 0
    .Col = 1: .text = "Rechteck: 1"
    .Col = 2: .text = "b [" + strEHL + "]"
    .Col = 3: .text = "h [" + strEHL + "]"
    .Col = 4: .text = "zs [" + strEHL + "]"
    .Row = 1
    .Col = 1: .text = "bzw. Profil: 2"
    .Col = 2: .text = "A [" + strEHL + "]"
    .Col = 3: .text = "I [" + strEHL + "4]"
    .Col = 4: .text = "zs [" + strEHL + "]"
    For i = 1 To N
      .Row = i + 1
      .Col = 0: .text = Format(i, "##")
      .Col = 1: .text = Format(Form(i), "#")
      .Col = 2: .text = Format(b(i), "#0.000")
      .Col = 3: .text = Format(h(i), "#0.000")
      .Col = 4: .text = Format(zs(i), "#0.000")
    Next i
  End If

  If strQuer = "P" Then                  'Fall P
    .Row = 0
    .Col = 1: .text = "y "
    .Col = 2: .text = "z "
    .Row = 1
    .Col = 1: .text = strEHL
    .Col = 2: .text = strEHL
    For i = 1 To N
      .Row = i + 1
      .Col = 0: .text = Format(i, "##")
      .Col = 1: .text = Format(y(i), "0.000")
      .Col = 2: .text = Format(z(i), "0.000")
    Next i
  End If

  If strQuer = "A" Then                   'Fall A
    .Row = 0
    .Col = 1: .text = "r "
    .Col = 2: .text = "alfa"
    .Col = 3: .text = "l "
    .Row = 1
    .Col = 1: .text = strEHL
    .Col = 2: .text = ""
    .Col = 3: .text = strEHL
    For i = 1 To NE
      .Row = i + 1
      .Col = 0: .text = Format(i, "##")
      .Col = 1: .text = Format(R(i), "0.000")
      .Col = 2: .text = Format(alfa(i), "0.000")
      .Col = 3: .text = Format(xL(i), "0.000")
    Next i
  End If
End With
End Sub   'EingabeYZ

Public Sub ErgebnisYZ()
'Ergebnisse in Flexgrid2 schreiben
Dim i As Integer, strF As String

With frm_Quer.MSFlexGrid2
  .ScrollBars = 0
  .FixedRows = 0
  .Rows = 6
  .Cols = 4
  .FixedCols = 2
  .ColWidth(0) = .Width * 0.25
  .ColWidth(1) = .Width * 0.15
  For i = 2 To 3
    .ColWidth(i) = .Width * 0.29
  Next i

  .FixedAlignment(0) = 2              'zentriert
  .Row = 0: .Col = 0: .text = "A "
  .Row = 0: .Col = 1: .text = strEHL & ""
  .Row = 1
  Select Case strQuer
    Case "T": .Col = 0: .text = "zs "
              .Col = 1: .text = strEHL
    Case Else: .Col = 0: .text = "zs, ys "
               .Col = 1: .text = strEHL
  End Select
  .Row = 2
  Select Case strQuer
    Case "T": .Col = 0: .text = "Iy "
              .Col = 1: .text = strEHL & "4"
    Case Else: .Col = 0: .text = "Iy, Iz "
               .Col = 1: .text = strEHL & "4"
  End Select

  If strQuer = "T" Then
    .Row = 3: .Col = 0: .text = "Wo "
              .Col = 1: .text = strEHL & ""
    .Row = 4: .Col = 0: .text = "Wu "
              .Col = 1: .text = strEHL & ""
    .Row = 5: .Col = 0: .text = "sigo/sigu "
              .Col = 1: .text = strEHF & "/" & strEHL & ""
  Else
    .Row = 3: .Col = 0: .text = "phi"
              .Col = 1: .text = ""
    .Row = 4: .Col = 0: .text = "I1, I2 "
              .Col = 1: .text = strEHL & "4"
    .Row = 5: .Col = 0: .text = "maxs/mins "
              .Col = 1: .text = strEHF & "/" & strEHL & ""
  End If

  If I1 > 100000 Or I2 > 100000 Then strF = "#0"
  If I1 > 1000 Or I2 > 1000 Then strF = "#0.00"
  If I1 <= 1000 Or I2 <= 1000 Then strF = "#0.0000"
  
  .Col = 2: .Row = 0: .text = Format(A, "#####0.0000")
  .Col = 2: .Row = 1: .text = Format(zzs, "#####0.0000")
  If strQuer = "T" Then
    .Col = 2: .Row = 2: .text = Format(Iy, strF)
    .Col = 2: .Row = 3: .text = Format(Wo, "#####0.0000")
    .Col = 2: .Row = 4: .text = Format(Wu, "#####0.0000")
    .Col = 2: .Row = 5: .text = Format(maxs, "#####0.00")
    .Col = 3: .Row = 5: .text = Format(mins, "#####0.00")
  Else
    .Col = 3: .Row = 1: .text = Format(ys, "#####0.0000")
    .Col = 2: .Row = 2: .text = Format(Iy, strF)
    .Col = 3: .Row = 2: .text = Format(Iz, strF)
    .Col = 2: .Row = 3: .text = Format(phi, "#0.00")
    .Col = 2: .Row = 4: .text = Format(I1, strF)
    .Col = 3: .Row = 4: .text = Format(I2, strF)
    .Col = 2: .Row = 5: .text = Format(maxs, "#0.00")
    .Col = 3: .Row = 5: .text = Format(mins, "#0.00")
  End If
End With

End Sub   'ErgebnisYZ

Public Sub Elschen()
'Eingabefelder lschen

With frm_Quer
  .Text5.text = ""
  .Text6.text = ""
  .Text7.text = ""
  .Text8.text = "1"
  .Text9.text = ""
  .Text10.text = ""
  .Text11.text = ""
  .Text12.text = ""
  .Text13.text = ""
  .Text14.text = ""
  .Text15.text = ""
  .Text16.text = ""
  'Ergebnisse
  .MSFlexGrid2.Clear
  .Picture1.Cls

  If strQuer = "T" Then
    .Text9.Visible = True
  Else
    .Text9.Visible = False
  End If
End With

End Sub   'Elschen


Public Sub neu()
Dim i As Integer

blnBerech = False
frm_Quer.Picture1.Cls
A = 0
zzs = 0
ys = 0
Iy = 0: Iz = 0
phi = 0
I1 = 0: I2 = 0
NS = 0: My = 0: Mz = 0
For i = 1 To N
  b(i) = 0: h(i) = 0: zs(i) = 0
  y(i) = 0: z(i) = 0
Next i
N = 1
For i = 1 To NE
  R(i) = 0: alfa(i) = 0: xL(i) = 0
Next i
NE = 1

A = 0: phi = 0: Iy = 0: Iz = 0: Wo = 0: Wu = 0: zzs = 0
maxs = 0: mins = 0

Call Elschen

End Sub   'neu

Public Sub Vorbelegung()
  Dim i As Integer
  strProjekt = "Test": strPosition = "1"
  strEHL = "cm": strEHF = "kN"           '5.1
  strDateiName = App.Path + "\" + "..."
  If strQuer = "" Then strQuer = "P"     '5.1
  Tol = 0.001                  'Toleranz = 1%
  blnGrafik = False              '5.1
  Select Case strQuer
    'fr QuerT: Vorgabe Rechteck
    Case "T": N = 1
              For i = 1 To N
                Form(i) = 1
                b(i) = 12            '5.1
                h(i) = 24            '5.1
                zs(i) = 12           '5.1
              Next i
              hg = 0.24
    
    'fr QuerP: Vorgabe Dreieck
    Case "P": N = 3
              y(1) = 0: z(1) = 0
              y(2) = 20: z(2) = 0
              y(3) = 10: z(3) = 10
    
    'fr QuerA: Vorgabe Dreieck mit Ausrundungen
    Case "A": NE = 3
              gamma = 10
              beta(0) = -90
              R(1) = 1: alfa(1) = 90: xL(1) = 10
              R(2) = 2: alfa(2) = 135: xL(2) = 14.142
              R(3) = 0: alfa(3) = 135: xL(3) = 10
    End Select
End Sub   'Vorbelegung

Public Sub LabelAktualisieren()
'Eingabeformat anpassen
Dim strfileBild As String

With frm_Quer
  .Label11.Caption = "Normalkraft N " + "[" + strEHF + "]"
  
  Select Case strQuer
  Case "T":
    If N = 0 Then N = 1
    strfileBild = App.Path + "\BildQuerT.jpg"
    .Caption = "Polygonal berandete Querschnitte Quer" + strQuer
    .Option1 = True
    .Label6.Caption = "Anzahl N der Teilquerschnitte"
    .Label7.Caption = vbCrLf + "Gesamthhe HG"
    .Label8.Caption = ""
    .Label9.Caption = "Nr./b/h/zs"
    .Label10.Caption = ""
    .Label12.Caption = "Biegemoment M " + "[" + strEHF + strEHL + "]"
    .Label13.Caption = ""
  
    .Text5.text = Str(N)
    .Text6.Visible = True       'HG
    .Text6.text = Str(hg)                 '5.1
    .Text7.Visible = False      'beta(0)
    .Text9.Visible = True       'Krit
    .Text12.Visible = True      'zs
    .Text13.Visible = False     'Tol
    .Text16.Visible = False     'Mz
    .Command3.Visible = False
  
  Case "P":
    If N < 3 Then N = 3
    strfileBild = App.Path + "\BildQuerP.jpg"
    .Caption = "Polygonal berandete Querschnitte Quer" + strQuer
    .Option2 = True
    .Label6.Caption = "Anzahl N der Eckpunkte"
    .Label7.Caption = ""
    .Label8.Caption = ""
    .Label9.Caption = "Nr./y/z"
    .Label10.Caption = ""
    .Label12.Caption = "Biegemoment My " + "[" + strEHF + strEHL + "]"
    .Label13.Caption = "Mz"
  
    .Text5.text = Str(N)
    .Text6.Visible = False      'HG
    .Text7.Visible = False      'beta(0)
    .Text9.Visible = False      'Krit
    .Text12.Visible = False     '4.Feld
    .Text13.Visible = False     'Tol
    .Text16.Visible = True      'Mz
    .Command3.Visible = False
  
  Case "A":
    If NE < 3 Then NE = 3
    strfileBild = App.Path + "\BildQuerA.jpg"
    .Caption = "Polygonal berandete Querschnitte mit Ausrundungen Quer" + strQuer
    .Option3 = True
    .Label6.Caption = "Anzahl N der Eckpunkte"
    .Label7.Caption = "Polygonwinkel Ausrundung gamma"
    .Label8.Caption = "Anfangswinkel beta0"
    .Label9.Caption = "Nr./r/alfa/l"
    .Label10.Caption = "Toleranz Anfang-/ Endpunkt in %"
    .Label12.Caption = "Biegemoment My " + "[" + strEHF + strEHL + "]"
    .Label13.Caption = "Mz"
  
    .Text5.text = Str(NE)
    .Text6.Visible = True       'gamma
    .Text6.text = Str(gamma)
    .Text7.Visible = True       'beta(0)
    .Text7.text = Str(beta(0))
    .Text9.Visible = False      'Krit
    .Text12.Visible = True      'beta(i)
    .Text13.Visible = True      'Tol
    .Text13.text = Format(100 * Tol, "#0.00")
    .Text13.ToolTipText = "Die " + Str(NE) + " Lngen l und Winkel alfa mssen - aneinandergereiht - nherungsweise den Ausgangspunkt ergeben!"
    .Text16.Visible = True      'Mz
    .Command3.Visible = True
    .Command3.ToolTipText = "Speichern im Format des Programms QuerP"
  End Select
  
  .Label11.Caption = "Normalkraft N " + "[" + strEHF + "]"
  'Bild
  .Image1.Stretch = True
  .Image1 = LoadPicture(strfileBild)
End With

End Sub   'LabelAktualisieren

Sub TexteAktualisieren()

With frm_Quer
  If strQuer = "T" Then
    .Text5.text = Str(N)
    .Text6.text = Format(hg, "####0.000")
  End If

  If strQuer = "P" Then
    .Text5.text = Str(N)
    .Text8.text = Format(1, "##")
    If y(1) = 0 Then
      .Text10.text = Format(y(1), "")
    Else
      .Text10.text = Format(y(1), "##0.000")
    End If
    If z(1) = 0 Then
      .Text11.text = Format(z(1), "")
    Else
      .Text11.text = Format(z(1), "##0.000")
    End If
  End If

  If strQuer = "A" Then
    .Text6.text = Format(gamma, "####0.000")
    .Text7.text = Format(beta(0), "####0.000")
    .Text5.text = Str(NE)
    .Text8.text = Format(1, "##")
    If R(1) = 0 Then
      .Text10.text = Format(R(1), "")
    Else
      .Text10.text = Format(R(1), "##0.000")
    End If
    If alfa(1) = 0 Then
      .Text11.text = Format(alfa(1), "")
    Else
      .Text11.text = Format(alfa(1), "##0.000")
    End If
    If xL(1) = 0 Then
      .Text12.text = Format(xL(1), "")
    Else
      .Text12.text = Format(xL(1), "##0.000")
    End If
  End If

  .Text14.text = Format(NS, "####0.000")
  .Text15.text = Format(My, "####0.000")
  .Text16.text = Format(Mz, "####0.000")
  .Label11.Caption = "Normalkraft N " + "[" + strEHF + "]"
  If strQuer = "T" Then
    .Label12.Caption = "Biegemoment M " + "[" + strEHF + strEHL + "]"
  Else
    .Label12.Caption = "Biegemoment My/Mz " + "[" + strEHF + strEHL + "]"
  End If

  Call EingabeYZ
  blnBerech = False

  Select Case strQuer
    Case "T":
      .Caption = "Aus Teilflchen zusammengesetzte Querschnitte QUER_" + strQuer + " " + Right$(strVersion, 3)
      .Option1.Value = True
    Case "P":
      .Caption = "Polygonal berandete Querschnitte QUER_" + strQuer + " " + Right$(strVersion, 3)
      .Option2.Value = True
    Case "A":
      .Caption = "Pol. ber. Querschnitte mit Ausrundungen QUER_" + strQuer + " " + Right$(strVersion, 3)
      .Option3.Value = True
  End Select
  
End With

Call Statusbar(MDIfrm_Quer)

End Sub   'TexteAktualisieren

Public Sub EingabeZ1()                    '5.1
  'Eingabezeile 1 belegen
  Select Case strQuer
    Case "T":
      frm_Quer.Text9.text = Str(Form(1))
      frm_Quer.Text10.text = Format(b(1), "##0.000")
      frm_Quer.Text11.text = Format(h(1), "##0.000")
      frm_Quer.Text12.text = Format(zs(1), "##0.000")
      frm_Quer.Text10.ToolTipText = "fr negative Flche A<0 eingeben"
    Case "P":
      frm_Quer.Text10.text = Format(y(1), "##0.000")
      frm_Quer.Text11.text = Format(z(1), "##0.000")
      frm_Quer.Text10.ToolTipText = ""
    Case "A":
      frm_Quer.Text10.text = Format(R(1), "##0.000")
      frm_Quer.Text11.text = Format(alfa(1), "##0.000")
      frm_Quer.Text12.text = Format(xL(1), "##0.000")
      frm_Quer.Text10.ToolTipText = ""
  End Select
End Sub
